#ifndef CYGONCE_HAL_PLATFORM_INTS_H
#define CYGONCE_HAL_PLATFORM_INTS_H
//==========================================================================
//
//      hal_platform_ints.h
//
//      HAL Interrupt and clock support
//
//==========================================================================
//####ECOSGPLCOPYRIGHTBEGIN####
// -------------------------------------------
// This file is part of eCos, the Embedded Configurable Operating System.
// Copyright (C) 1998, 1999, 2000, 2001, 2002 Red Hat, Inc.
//
// eCos is free software; you can redistribute it and/or modify it under
// the terms of the GNU General Public License as published by the Free
// Software Foundation; either version 2 or (at your option) any later version.
//
// eCos is distributed in the hope that it will be useful, but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or
// FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
// for more details.
//
// You should have received a copy of the GNU General Public License along
// with eCos; if not, write to the Free Software Foundation, Inc.,
// 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.
//
// As a special exception, if other files instantiate templates or use macros
// or inline functions from this file, or you compile this file and link it
// with other works to produce a work based on this file, this file does not
// by itself cause the resulting work to be covered by the GNU General Public
// License. However the source code for this file must still be made available
// in accordance with section (3) of the GNU General Public License.
//
// This exception does not invalidate any other reasons why a work based on
// this file might be covered by the GNU General Public License.
//
// Alternative licenses for eCos may be arranged by contacting Red Hat, Inc.
// at http://sources.redhat.com/ecos/ecos-license/
// -------------------------------------------
//####ECOSGPLCOPYRIGHTEND####
//==========================================================================
//#####DESCRIPTIONBEGIN####
//
// Author(s):    michael anburaj <michaelanburaj@hotmail.com>
// Contributors: michael anburaj <michaelanburaj@hotmail.com>
// Date:         2003-08-01
// Purpose:      Define Interrupt support
// Description:  The interrupt details for the Samsung SMDK2410 are defined here.
// Usage:
//               #include <cyg/hal/hal_platform_ints.h>
//               ...
//              
//
//####DESCRIPTIONEND####
//
//==========================================================================


// *****************************************************************************
//               PERIPHERAL ID DEFINITIONS FOR AT91RM9200
// *****************************************************************************
#define CYGNUM_HAL_INTERRUPT_FIQ		0
#define CYGNUM_HAL_INTERRUPT_SYS		1
#define CYGNUM_HAL_INTERRUPT_PIOA		2
#define CYGNUM_HAL_INTERRUPT_PIOB		3
#define CYGNUM_HAL_INTERRUPT_PIOC		4
#define CYGNUM_HAL_INTERRUPT_USART0		6
#define CYGNUM_HAL_INTERRUPT_USART1		7
#define CYGNUM_HAL_INTERRUPT_USART2		8
#define CYGNUM_HAL_INTERRUPT_USART3		9
#define CYGNUM_HAL_INTERRUPT_MCI		10
#define CYGNUM_HAL_INTERRUPT_UDP		11
#define CYGNUM_HAL_INTERRUPT_TWI		12
#define CYGNUM_HAL_INTERRUPT_SPI		13
#define CYGNUM_HAL_INTERRUPT_SSC0		14
#define CYGNUM_HAL_INTERRUPT_SSC1		15
#define CYGNUM_HAL_INTERRUPT_SSC2		16
#define CYGNUM_HAL_INTERRUPT_TC0		17
#define CYGNUM_HAL_INTERRUPT_TC1		18
#define CYGNUM_HAL_INTERRUPT_TC2		19
#define CYGNUM_HAL_INTERRUPT_TC3		20
#define CYGNUM_HAL_INTERRUPT_TC4		21
#define CYGNUM_HAL_INTERRUPT_TC5		22
#define CYGNUM_HAL_INTERRUPT_UHP		23
#define CYGNUM_HAL_INTERRUPT_EMAC		24
#define CYGNUM_HAL_INTERRUPT_IRQ0		25
#define CYGNUM_HAL_INTERRUPT_IRQ1		26
#define CYGNUM_HAL_INTERRUPT_IRQ2		27
#define CYGNUM_HAL_INTERRUPT_IRQ3		28
#define CYGNUM_HAL_INTERRUPT_IRQ4		29
#define CYGNUM_HAL_INTERRUPT_IRQ5		30
#define CYGNUM_HAL_INTERRUPT_IRQ6		31

#define CYGNUM_HAL_INTERRUPT_ALL		((unsigned int) 0xFFFFFFFF) // ALL VALID INTERRUPTS


// Interrupts which are multiplexed on to the System Interrupt
//============================================================
#define CYGNUM_HAL_INTERRUPT_ST     	32
#define CYGNUM_HAL_INTERRUPT_RTTC     	33
#define CYGNUM_HAL_INTERRUPT_PMC      	34
#define CYGNUM_HAL_INTERRUPT_SDRAMC    	35
#define CYGNUM_HAL_INTERRUPT_DBG        36



#define CYGNUM_HAL_ISR_MIN            0
#define CYGNUM_HAL_ISR_MAX            36
#define CYGNUM_HAL_ISR_COUNT          (CYGNUM_HAL_ISR_MAX-CYGNUM_HAL_ISR_MIN+1)

// The vector used by the Real time clock
//=======================================
//#define CYGNUM_HAL_INTERRUPT_RTC      CYGNUM_HAL_INTERRUPT_SYS
#define CYGNUM_HAL_INTERRUPT_RTC      CYGNUM_HAL_INTERRUPT_TC0




//----------------------------------------------------------------------------
// Reset.

// Watchdog is started with a very small delay to Reset immediatly.
#define HAL_PLATFORM_RESET()                                     \
do {                                                             \
    HAL_WRITE_UINT32(0, 0);                                  \
    HAL_WRITE_UINT32(0, 1);                                  \
    HAL_WRITE_UINT32(0, (1<<0)|(0<<2)|(0<<3)|(1<<5)|(0<<8)); \
} while(0)

// Base of flash
#define HAL_PLATFORM_RESET_ENTRY 0x00000000

#endif // CYGONCE_HAL_PLATFORM_INTS_H
