#ifndef CYGONCE_HAL_PLF_IO_H
#define CYGONCE_HAL_PLF_IO_H
//=============================================================================
//
//      plf_io.h
//
//      AT91RM9200 board specific registers
//
//=============================================================================
//####ECOSGPLCOPYRIGHTBEGIN####
// -------------------------------------------
// This file is part of eCos, the Embedded Configurable Operating System.
// Copyright (C) 1998, 1999, 2000, 2001, 2002 Red Hat, Inc.
//
// eCos is free software; you can redistribute it and/or modify it under
// the terms of the GNU General Public License as published by the Free
// Software Foundation; either version 2 or (at your option) any later version.
//
// eCos is distributed in the hope that it will be useful, but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or
// FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
// for more details.
//
// You should have received a copy of the GNU General Public License along
// with eCos; if not, write to the Free Software Foundation, Inc.,
// 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.
//
// As a special exception, if other files instantiate templates or use macros
// or inline functions from this file, or you compile this file and link it
// with other works to produce a work based on this file, this file does not
// by itself cause the resulting work to be covered by the GNU General Public
// License. However the source code for this file must still be made available
// in accordance with section (3) of the GNU General Public License.
//
// This exception does not invalidate any other reasons why a work based on
// this file might be covered by the GNU General Public License.
// -------------------------------------------
//####ECOSGPLCOPYRIGHTEND####
//=============================================================================
//#####DESCRIPTIONBEGIN####
//
// Author(s):   ilko iliev
// Contributors: 
// Date:        2006-04-10
// Purpose:     Atmel AT91RM9200 board specific registers
// Description: 
// Usage:       #include <cyg/hal/plf_io.h>
//
//####DESCRIPTIONEND####
//
//=============================================================================
#include "at91rm9200.h"

#define CYGARC_PHYSICAL_ADDRESS(_x_)


#define AT91_PMC					(int)AT91C_BASE_PMC
#define	AT91_PMC_PCER				0x10
#define AT91_PMC_PCDR				0x14
#define AT91_PMC_IMR				0x6C
#define AT91_PMC_SR					0x68
  #define AT91_PMC_SR_MOSCS   		AT91C_PMC_MOSCS 					// Main oscillator stable
  #define AT91_PMC_SR_LOCK    		AT91C_PMC_LOCKA 					// PLL Locked
  #define AT91_PMC_SR_MCKRDY  		AT91C_PMC_MCKRDY 					// MCK is ready to be enabled
  #define AT91_PMC_SR_PCK0RDY 		AT91C_PMC_PCK0RDY 					// Pad clock 0 is ready to be enabled
  #define AT91_PMC_SR_PCK1RDY 		AT91C_PMC_PCK1RDY 					// Pad clock 1 is ready to be enabled
  #define AT91_PMC_SR_PCK2RDY 		AT91C_PMC_PCK2RDY 					// Pad clock 2 is ready to be enabled
  #define AT91_PMC_SR_PCK3RDY 		AT91C_PMC_PCK3RDY 					// Pad clock 3 is ready to be enabled
	
#define AT91_PMC_MCKR 				0x30 								// Master Clock Register
  #define AT91_PMC_MCKR_SLOW_CLK 	AT91C_PMC_CSS_SLOW_CLK 				// Slow clock selected
  #define AT91_PMC_MCKR_MAIN_CLK 	AT91C_PMC_CSS_MAIN_CLK 				// Main clock selected
  #define AT91_PMC_MCKR_PLL_CLK 	AT91C_PMC_CSS_PLLA_CLK 				// PLLA clock selected

#define AT91_US_PTCR				0x120
#define AT91_US_PTSR				0x124
#define AT91_US_PTCR_RXTEN 			AT91C_PDC_RXTEN	
#define AT91_US_PTCR_TXTEN			AT91C_PDC_TXTEN




#define AT91_SPI         			(int)AT91C_BASE_SPI					// SPI0 base address
#define	AT91_SPI_CR					0
  #define AT91_SPI_CR_SWRST			AT91C_SPI_SWRST
  #define AT91_SPI_CR_SPIEN			AT91C_SPI_SPIEN
  #define AT91_SPI_CR_SPIDIS		AT91C_SPI_SPIDIS	
  
#define	AT91_SPI_MR					0x04
  #define AT91_SPI_MR_MSTR			(AT91C_SPI_MSTR | AT91C_SPI_MODFDIS) 
//  #define AT91_SPI_MR_MSTR			((AT91C_SPI_MSTR | AT91C_SPI_MODFDIS) + (80&AT91C_SPI_DLYBCS))	
  #define AT91_SPI_MR_DIV32			AT91C_SPI_DIV32

#define	AT91_SPI_RDR				0x08
#define	AT91_SPI_TDR				0x0C
#define AT91_SPI_SR					0x10
  #define AT91_SPI_SR_ENDRX			AT91C_SPI_SPENDRX
  #define AT91_SPI_SR_ENDTX			AT91C_SPI_SPENDTX
  #define AT91_SPI_SR_TDRE			AT91C_SPI_TDRE
  #define AT91_SPI_SR_RDRF			AT91C_SPI_RDRF

#define	AT91_SPI_IER				0x14
#define	AT91_SPI_IDR				0x18

#define	AT91_SPI_CSR0				0x30
  #define AT91_SPI_CSR_BITS8		AT91C_SPI_BITS_8
  #define AT91_SPI_CSR_CPOL			AT91C_SPI_CPOL	
  #define AT91_SPI_CSR_NCPHA		AT91C_SPI_NCPHA	
  

#define	AT91_SPI_RPR				0x100
#define	AT91_SPI_RCR				0x104
#define	AT91_SPI_TPR				0x108
#define	AT91_SPI_TCR				0x10C
#define	AT91_SPI_PTCR				0x120
	#define	AT91_PDC_RXTEN			AT91C_PDC_RXTEN
	#define	AT91_PDC_TXTEN			AT91C_PDC_TXTEN
	#define	AT91_PDC_RXTDIS			AT91C_PDC_RXTDIS
	#define	AT91_PDC_TXTDIS			AT91C_PDC_TXTDIS


#define AT91_SPI_PIO         		(int)AT91C_BASE_PIOA				// PIOA base address

#define	AT91_PIO_PSR_NPCS0			AT91C_PA3_NPCS0
#define	AT91_PIO_PSR_NPCS1			AT91C_PA4_NPCS1
#define	AT91_PIO_PSR_NPCS2			AT91C_PA5_NPCS2
#define	AT91_PIO_PSR_NPCS3			AT91C_PA6_NPCS3

#define AT91_SPI_PIO_NPCS(x)                   \
   ( (x & (1 << 0) ? AT91_PIO_PSR_NPCS0 : 0) | \
     (x & (1 << 1) ? AT91_PIO_PSR_NPCS1 : 0) | \
     (x & (1 << 2) ? AT91_PIO_PSR_NPCS2 : 0) | \
     (x & (1 << 3) ? AT91_PIO_PSR_NPCS3 : 0))

#define	AT91_SPI_CSR_SCBR(x)		(((x)&0xFF)<<8)   				// Serial Clock Baud Rate 

#define AT91_SPI_CSR_BITS(nbits)	((nbits-8) << 4 )					

#define	AT91_PIO_OER				0x10
#define AT91_PIO_SODR				0x30
#define AT91_PIO_CODR				0x34
#define	AT91_PIO_PSR_SPCK			AT91C_PA2_SPCK
#define	AT91_PIO_PSR_MISO			AT91C_PA0_MISO
#define	AT91_PIO_PSR_MOIS			AT91C_PA1_MOSI

#define	AT91_PMC_PCER_SPI			(1 << AT91C_ID_SPI)



#ifndef __ASSEMBLER__
#ifdef CYGBLD_HAL_ARM_AT91_BAUD_DYNAMIC
extern cyg_uint32 hal_at91_us_baud(cyg_uint32 baud);
#define AT91_US_BAUD(baud) hal_at91_us_baud(baud)
#endif
#endif // __ASSEMBLER__

//----------------------------------------------------------------------
// The platform needs this initialization during the
// hal_hardware_init() function in the varient HAL.
#ifndef __ASSEMBLER__
extern void hal_plf_hardware_init(void);
#define HAL_PLF_HARDWARE_INIT() \
    hal_plf_hardware_init()
#endif          



#endif //CYGONCE_HAL_PLF_IO_H

