#ifndef CYGONCE_HAL_VAR_IO_H
#define CYGONCE_HAL_VAR_IO_H
//=============================================================================
//
//      var_io.h
//
//      Variant specific registers
//
//=============================================================================
//####ECOSGPLCOPYRIGHTBEGIN####
// -------------------------------------------
// This file is part of eCos, the Embedded Configurable Operating System.
// Copyright (C) 1998, 1999, 2000, 2001, 2002 Red Hat, Inc.
// Copyright (C) 2003 Nick Garnett <nickg@calivar.com>
// Copyright (C) 2005, 2006 Andrew Lunn (andrew.lunn@ascom.ch>
//
// eCos is free software; you can redistribute it and/or modify it under
// the terms of the GNU General Public License as published by the Free
// Software Foundation; either version 2 or (at your option) any later version.
//
// eCos is distributed in the hope that it will be useful, but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or
// FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
// for more details.
//
// You should have received a copy of the GNU General Public License along
// with eCos; if not, write to the Free Software Foundation, Inc.,
// 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.
//
// As a special exception, if other files instantiate templates or use macros
// or inline functions from this file, or you compile this file and link it
// with other works to produce a work based on this file, this file does not
// by itself cause the resulting work to be covered by the GNU General Public
// License. However the source code for this file must still be made available
// in accordance with section (3) of the GNU General Public License.
//
// This exception does not invalidate any other reasons why a work based on
// this file might be covered by the GNU General Public License.
// -------------------------------------------
//####ECOSGPLCOPYRIGHTEND####
//=============================================================================
//#####DESCRIPTIONBEGIN####
//
// Author(s):   jskov
// Contributors:jskov, gthomas, tkoeller, tdrury, nickg, asl, John Eigelaar
// Date:        2001-07-12
// Purpose:     AT91 variant specific registers
// Description: 
// Usage:       #include <cyg/hal/var_io.h>
//
//####DESCRIPTIONEND####
//
//=============================================================================

#include <cyg/hal/plf_io.h>


#define AT91_PIN(_ctrl_, _periph_, _pin_) \
  ((_ctrl_ << 16) | (_periph_ << 8) | (_pin_))

// GPIO pins on PIO A.
#define AT91_GPIO_PA0       AT91_PIN(0,0, 0)
#define AT91_GPIO_PA1       AT91_PIN(0,0, 1)
#define AT91_GPIO_PA2       AT91_PIN(0,0, 2)
#define AT91_GPIO_PA3       AT91_PIN(0,0, 3)
#define AT91_GPIO_PA4       AT91_PIN(0,0, 4)
#define AT91_GPIO_PA5       AT91_PIN(0,0, 5)
#define AT91_GPIO_PA6       AT91_PIN(0,0, 6)
#define AT91_GPIO_PA7       AT91_PIN(0,0, 7)
#define AT91_GPIO_PA8       AT91_PIN(0,0, 8)
#define AT91_GPIO_PA9       AT91_PIN(0,0, 9)
#define AT91_GPIO_PA10      AT91_PIN(0,0,10)
#define AT91_GPIO_PA11      AT91_PIN(0,0,11)
#define AT91_GPIO_PA12      AT91_PIN(0,0,12)
#define AT91_GPIO_PA13      AT91_PIN(0,0,13)
#define AT91_GPIO_PA14      AT91_PIN(0,0,14)
#define AT91_GPIO_PA15      AT91_PIN(0,0,15)
#define AT91_GPIO_PA16      AT91_PIN(0,0,16)
#define AT91_GPIO_PA17      AT91_PIN(0,0,17)
#define AT91_GPIO_PA18      AT91_PIN(0,0,18)
#define AT91_GPIO_PA19      AT91_PIN(0,0,19)
#define AT91_GPIO_PA20      AT91_PIN(0,0,20)
#define AT91_GPIO_PA21      AT91_PIN(0,0,21)
#define AT91_GPIO_PA22      AT91_PIN(0,0,22)
#define AT91_GPIO_PA23      AT91_PIN(0,0,23)
#define AT91_GPIO_PA24      AT91_PIN(0,0,24)
#define AT91_GPIO_PA25      AT91_PIN(0,0,25)
#define AT91_GPIO_PA26      AT91_PIN(0,0,26)
#define AT91_GPIO_PA27      AT91_PIN(0,0,27)
#define AT91_GPIO_PA28      AT91_PIN(0,0,28)
#define AT91_GPIO_PA29      AT91_PIN(0,0,29)
#define AT91_GPIO_PA30      AT91_PIN(0,0,30)
#define AT91_GPIO_PA31      AT91_PIN(0,0,31)

#ifdef AT91_PIOB
// GPIO pins on PIOB.
#define AT91_GPIO_PB0       AT91_PIN(1,0, 0)
#define AT91_GPIO_PB1       AT91_PIN(1,0, 1)
#define AT91_GPIO_PB2       AT91_PIN(1,0, 2)
#define AT91_GPIO_PB3       AT91_PIN(1,0, 3)
#define AT91_GPIO_PB4       AT91_PIN(1,0, 4)
#define AT91_GPIO_PB5       AT91_PIN(1,0, 5)
#define AT91_GPIO_PB6       AT91_PIN(1,0, 6)
#define AT91_GPIO_PB7       AT91_PIN(1,0, 7)
#define AT91_GPIO_PB8       AT91_PIN(1,0, 8)
#define AT91_GPIO_PB9       AT91_PIN(1,0, 9)
#define AT91_GPIO_PB10      AT91_PIN(1,0,10)
#define AT91_GPIO_PB11      AT91_PIN(1,0,11)
#define AT91_GPIO_PB12      AT91_PIN(1,0,12)
#define AT91_GPIO_PB13      AT91_PIN(1,0,13)
#define AT91_GPIO_PB14      AT91_PIN(1,0,14)
#define AT91_GPIO_PB15      AT91_PIN(1,0,15)
#define AT91_GPIO_PB16      AT91_PIN(1,0,16)
#define AT91_GPIO_PB17      AT91_PIN(1,0,17)
#define AT91_GPIO_PB18      AT91_PIN(1,0,18)
#define AT91_GPIO_PB19      AT91_PIN(1,0,19)
#define AT91_GPIO_PB20      AT91_PIN(1,0,20)
#define AT91_GPIO_PB21      AT91_PIN(1,0,21)
#define AT91_GPIO_PB22      AT91_PIN(1,0,22)
#define AT91_GPIO_PB23      AT91_PIN(1,0,23)
#define AT91_GPIO_PB24      AT91_PIN(1,0,24)
#define AT91_GPIO_PB25      AT91_PIN(1,0,25)
#define AT91_GPIO_PB26      AT91_PIN(1,0,26)
#define AT91_GPIO_PB27      AT91_PIN(1,0,27)
#define AT91_GPIO_PB28      AT91_PIN(1,0,28)
#define AT91_GPIO_PB29      AT91_PIN(1,0,29)
#define AT91_GPIO_PB30      AT91_PIN(1,0,30)
#define AT91_GPIO_PB31      AT91_PIN(1,0,31)
#endif //AT91_PIOB

#ifdef AT91_PIOC
// GPIO pins on PIOC.
#define AT91_GPIO_PC0       AT91_PIN(2,0, 0)
#define AT91_GPIO_PC1       AT91_PIN(2,0, 1)
#define AT91_GPIO_PC2       AT91_PIN(2,0, 2)
#define AT91_GPIO_PC3       AT91_PIN(2,0, 3)
#define AT91_GPIO_PC4       AT91_PIN(2,0, 4)
#define AT91_GPIO_PC5       AT91_PIN(2,0, 5)
#define AT91_GPIO_PC6       AT91_PIN(2,0, 6)
#define AT91_GPIO_PC7       AT91_PIN(2,0, 7)
#define AT91_GPIO_PC8       AT91_PIN(2,0, 8)
#define AT91_GPIO_PC9       AT91_PIN(2,0, 9)
#define AT91_GPIO_PC10      AT91_PIN(2,0,10)
#define AT91_GPIO_PC11      AT91_PIN(2,0,11)
#define AT91_GPIO_PC12      AT91_PIN(2,0,12)
#define AT91_GPIO_PC13      AT91_PIN(2,0,13)
#define AT91_GPIO_PC14      AT91_PIN(2,0,14)
#define AT91_GPIO_PC15      AT91_PIN(2,0,15)
#define AT91_GPIO_PC16      AT91_PIN(2,0,16)
#define AT91_GPIO_PC17      AT91_PIN(2,0,17)
#define AT91_GPIO_PC18      AT91_PIN(2,0,18)
#define AT91_GPIO_PC19      AT91_PIN(2,0,19)
#define AT91_GPIO_PC20      AT91_PIN(2,0,20)
#define AT91_GPIO_PC21      AT91_PIN(2,0,21)
#define AT91_GPIO_PC22      AT91_PIN(2,0,22)
#define AT91_GPIO_PC23      AT91_PIN(2,0,23)
#define AT91_GPIO_PC24      AT91_PIN(2,0,24)
#define AT91_GPIO_PC25      AT91_PIN(2,0,25)
#define AT91_GPIO_PC26      AT91_PIN(2,0,26)
#define AT91_GPIO_PC27      AT91_PIN(2,0,27)
#define AT91_GPIO_PC28      AT91_PIN(2,0,28)
#define AT91_GPIO_PC29      AT91_PIN(2,0,29)
#define AT91_GPIO_PC30      AT91_PIN(2,0,30)
#define AT91_GPIO_PC31      AT91_PIN(2,0,31)
#endif //AT91_PIOC



#if defined(CYGHWR_HAL_ARM_AT91RM9200)

	#include "var_9200.h"

#elif defined(CYGHWR_HAL_ARM_AT91SAM9261)		

	#include "var_sam9.h"

#elif defined(CYGHWR_HAL_ARM_AT91_M42800A)

	#include "var_42800a.h"
	
#elif defined(CYGHWR_HAL_ARM_AT91_M55800A)

	#include "var_m55800.h"
	
#elif defined(CYGHWR_HAL_ARM_AT91SAM7)
	
	#include "var_sam7.h"
	
#endif		


//=============================================================================
// FIQ interrupt vector which is shared by all HAL varients.

#define CYGNUM_HAL_INTERRUPT_FIQ 0

// Macros for access the GPIO lines and configuring peripheral pins

// Given a pin description, determine which PIO controller it is on
#define HAL_ARM_AT91_PIO_CTRL(_pin_)            \
  ((_pin_ >> 16) & 0xff)

// Given a pin description, determine which PIO bit controls this pin
#define HAL_ARM_AT91_PIO_BIT(_pin_)             \
  (1 << (_pin_ & 0xff))

// Evaluate to true if the pin is using peripheral A
#define HAL_ARM_AT91_PIO_A(_pin_)               \
  (((_pin_ >> 8) & 0xff) == 0)

// Configure a peripheral pin on a specific PIO controller.
#ifdef AT91_PIO_ASR
#define HAL_ARM_AT91_PIOX_CFG(_pin_, _nr_, _pio_base_)                  \
  CYG_MACRO_START                                                       \
  if (HAL_ARM_AT91_PIO_CTRL(_pin_) == (_nr_)) {                         \
    HAL_WRITE_UINT32((_pio_base_)+AT91_PIO_PDR,                         \
                     HAL_ARM_AT91_PIO_BIT(_pin_));                      \
    if (HAL_ARM_AT91_PIO_A(_pin_)) {                                    \
      HAL_WRITE_UINT32((_pio_base_)+AT91_PIO_ASR,                       \
                       HAL_ARM_AT91_PIO_BIT(_pin_));                    \
    } else {                                                            \
      HAL_WRITE_UINT32((_pio_base_)+AT91_PIO_BSR,                       \
                       HAL_ARM_AT91_PIO_BIT(_pin_));                    \
    }                                                                   \
  }                                                                     \
  CYG_MACRO_END
#else // AT91_PIO_ASR
#define HAL_ARM_AT91_PIOX_CFG(_pin_, _nr_, _pio_base_)                  \
  CYG_MACRO_START                                                       \
  if (HAL_ARM_AT91_PIO_CTRL(_pin_) == (_nr_)) {                         \
    HAL_WRITE_UINT32((_pio_base_)+AT91_PIO_PDR,                         \
                     HAL_ARM_AT91_PIO_BIT(_pin_));                      \
  }                                                                     \
  CYG_MACRO_END
#endif // !AT91_PIO_ASR

// Configure a GPIO pin direction on a specific PIO controller.
#define HAL_ARM_AT91_GPIOX_CFG_DIRECTION(_pin_, _dir_, _nr_, _pio_base_) 	\
  	CYG_MACRO_START                                                      	\
  	if (HAL_ARM_AT91_PIO_CTRL(_pin_) == (_nr_)) 							\
  	{                         												\
  		HAL_WRITE_UINT32((_pio_base_)+AT91_PIO_PER,                         \
                     	HAL_ARM_AT91_PIO_BIT(_pin_));                      	\
    	if ((_dir_) == AT91_PIN_IN) 										\
    	{                                       							\
      		HAL_WRITE_UINT32((_pio_base_)+AT91_PIO_ODR,                     \
                       	HAL_ARM_AT91_PIO_BIT(_pin_));                    	\
    	} 																	\
    	else 																\
    	{                                                            		\
      		HAL_WRITE_UINT32((_pio_base_)+AT91_PIO_OER,                     \
                         	HAL_ARM_AT91_PIO_BIT(_pin_));                  	\
    	}                                                                   \
  	}                                                                     	\
  	CYG_MACRO_END

// Configure a GPIO pin pullup on a specific PIO controller.
#define HAL_ARM_AT91_GPIOX_CFG_PULLUP(_pin_, _enable_, _nr_, _pio_base_) \
  CYG_MACRO_START                                                       \
  if (HAL_ARM_AT91_PIO_CTRL(_pin_) == (_nr_)) {                         \
    if (_enable_) {                                                     \
      HAL_WRITE_UINT32((_pio_base_)+AT91_PIO_PPUER,                     \
                       HAL_ARM_AT91_PIO_BIT(_pin_));                    \
    } else {                                                            \
      HAL_WRITE_UINT32((_pio_base_)+AT91_PIO_PPUDR,                     \
                         HAL_ARM_AT91_PIO_BIT(_pin_));                  \
    }                                                                   \
  }                                                                     \
  CYG_MACRO_END


// Configure a GPIO pin multi driver on a specific PIO controller.
#define HAL_ARM_AT91_GPIOX_CFG_MULTI(_pin_, _enable_, _nr_, _pio_base_) \
  CYG_MACRO_START                                                       \
  if (HAL_ARM_AT91_PIO_CTRL(_pin_) == (_nr_)) {                         \
    if (_enable_) {                                                     \
      HAL_WRITE_UINT32((_pio_base_)+AT91_PIO_MDER,                     \
                       HAL_ARM_AT91_PIO_BIT(_pin_));                    \
    } else {                                                            \
      HAL_WRITE_UINT32((_pio_base_)+AT91_PIO_MDER,                     \
                         HAL_ARM_AT91_PIO_BIT(_pin_));                  \
    }                                                                   \
  }                                                                     \
  CYG_MACRO_END





// Set a GPIO pin on a specific PIO controller to generate interrupts
#define HAL_ARM_AT91_GPIOX_CFG_INTERRUPT(_pin_, _enable_, _nr_, _pio_base_) \
  CYG_MACRO_START                                                       \
  if (HAL_ARM_AT91_PIO_CTRL(_pin_) == (_nr_)) {                         \
    if (_enable_) {                                                     \
      HAL_WRITE_UINT32((_pio_base_)+AT91_PIO_IER,                       \
                       HAL_ARM_AT91_PIO_BIT(_pin_));                    \
    } else {                                                            \
      HAL_WRITE_UINT32((_pio_base_)+AT91_PIO_IDR,                       \
                         HAL_ARM_AT91_PIO_BIT(_pin_));                  \
    }                                                                   \
  }                                                                     \
  CYG_MACRO_END

// Set a GPIO pin on a specific PIO controller.
#define HAL_ARM_AT91_GPIOX_SET(_pin_, _nr_, _pio_base_) \
  CYG_MACRO_START                                                       \
  if (HAL_ARM_AT91_PIO_CTRL(_pin_) == (_nr_)) {                         \
    HAL_WRITE_UINT32((_pio_base_)+AT91_PIO_SODR,                        \
                     HAL_ARM_AT91_PIO_BIT(_pin_));                      \
  }                                                                     \
  CYG_MACRO_END

// Reset a GPIO pin on a specific PIO controller.
#define HAL_ARM_AT91_GPIOX_RESET(_pin_, _nr_, _pio_base_) \
  CYG_MACRO_START                                                       \
  if (HAL_ARM_AT91_PIO_CTRL(_pin_) == (_nr_)) {                         \
    HAL_WRITE_UINT32((_pio_base_)+AT91_PIO_CODR,                        \
                     HAL_ARM_AT91_PIO_BIT(_pin_));                      \
  }                                                                     \
  CYG_MACRO_END

// Get a GPIO pin on a specific PIO controller.
#define HAL_ARM_AT91_GPIOX_GET(_pin_, _value_, _nr_, _pio_base_)        \
  CYG_MACRO_START                                                       \
  cyg_uint32 _pdsr_;                                                    \
  if (HAL_ARM_AT91_PIO_CTRL(_pin_) == (_nr_)) {                         \
    HAL_READ_UINT32((_pio_base_)+AT91_PIO_PDSR, _pdsr_);                \
    (_value_) = (_pdsr_ & HAL_ARM_AT91_PIO_BIT(_pin_) ? 1 : 0);         \
  }                                                                     \
  CYG_MACRO_END

// check the interrupt source
#define HAL_ARM_AT91_GPIOX_GET_IS( _pin_, _level_, _value_, _nr_, _pio_base_)	\
  	CYG_MACRO_START                                                     		\
  	_value_ = false;															\
  	if (HAL_ARM_AT91_PIO_CTRL(_pin_) == (_nr_)) 								\
  	{                        													\
  		cyg_uint32 _isr_, mask = 1 << (_pin_&0xFF);								\
		HAL_READ_UINT32( (_pio_base_)+AT91_PIO_ISR, _isr_ );					\
		if ( _isr_ & mask )														\
		{																		\
  			cyg_uint32 _pdsr_;													\
  			HAL_READ_UINT32((_pio_base_)+AT91_PIO_PDSR, _pdsr_);        		\
  			if ( _level_ )														\
  			{																	\
				if ( _pdsr_ & mask )											\
					_value_ = true;												\
			}																	\
			else																\
			{																	\
				if ( !(_pdsr_ & mask) )											\
					_value_ = true;												\
			}																	\
		}																		\
	}																			\
  	CYG_MACRO_END


#define AT91_PIN_IN  				1
#define AT91_PIN_OUT 				0
#define AT91_PIN_PULLUP_ENABLE  	1
#define AT91_PIN_PULLUP_DISABLE 	0
#define AT91_PIN_INTERRUPT_ENABLE  	1
#define AT91_PIN_INTERRUPT_DISABLE 	0


#ifdef AT91_PIOC
//====================================================================
// 					Three PIO controllers
//====================================================================

// Configure a peripheral pin for peripheral operation
#define HAL_ARM_AT91_PIO_CFG(_pin_)             					\
  CYG_MACRO_START                               					\
  HAL_ARM_AT91_PIOX_CFG(_pin_, 0, AT91_PIO);        				\
  HAL_ARM_AT91_PIOX_CFG(_pin_, 1, AT91_PIOB);       				\
  HAL_ARM_AT91_PIOX_CFG(_pin_, 2, AT91_PIOC);       				\
CYG_MACRO_END

// Configure a GPIO pin direction
#define HAL_ARM_AT91_GPIO_CFG_DIRECTION(_pin_, _dir_)            	\
  CYG_MACRO_START                                                	\
  HAL_ARM_AT91_GPIOX_CFG_DIRECTION(_pin_, _dir_, 0, AT91_PIO);   	\
  HAL_ARM_AT91_GPIOX_CFG_DIRECTION(_pin_, _dir_, 1, AT91_PIOB);  	\
  HAL_ARM_AT91_GPIOX_CFG_DIRECTION(_pin_, _dir_, 2, AT91_PIOC);  	\
  CYG_MACRO_END

// Configure a GPIO pin pullup resistor
#define HAL_ARM_AT91_GPIO_CFG_PULLUP(_pin_, _enable_)               \
  CYG_MACRO_START                                                   \
  HAL_ARM_AT91_GPIOX_CFG_PULLUP(_pin_, _enable_, 0, AT91_PIO);      \
  HAL_ARM_AT91_GPIOX_CFG_PULLUP(_pin_, _enable_, 1, AT91_PIOB);     \
  HAL_ARM_AT91_GPIOX_CFG_PULLUP(_pin_, _enable_, 2, AT91_PIOC);     \
  CYG_MACRO_END

// Configure a GPIO pin MULTI driver
#define HAL_ARM_AT91_GPIO_CFG_MULTI(_pin_, _enable_)                \
  CYG_MACRO_START                                                   \
  HAL_ARM_AT91_GPIOX_CFG_MULTI(_pin_, _enable_, 0, AT91_PIO);      \
  HAL_ARM_AT91_GPIOX_CFG_MULTI(_pin_, _enable_, 1, AT91_PIOB);     \
  HAL_ARM_AT91_GPIOX_CFG_MULTI(_pin_, _enable_, 2, AT91_PIOC);     \
  CYG_MACRO_END

// Configure a GPIO pin to generate interrupts
#define HAL_ARM_AT91_GPIO_CFG_INTERRUPT(_pin_, _enable_)            \
  CYG_MACRO_START                                                   \
  HAL_ARM_AT91_GPIOX_CFG_INTERRUPT(_pin_, _enable_, 0, AT91_PIO);   \
  HAL_ARM_AT91_GPIOX_CFG_INTERRUPT(_pin_, _enable_, 1, AT91_PIOB);  \
  HAL_ARM_AT91_GPIOX_CFG_INTERRUPT(_pin_, _enable_, 2, AT91_PIOC);  \
  CYG_MACRO_END

// Set a GPIO pin to 1
#define HAL_ARM_AT91_GPIO_SET(_pin_)                                \
  CYG_MACRO_START                                                   \
  HAL_ARM_AT91_GPIOX_SET(_pin_, 0, AT91_PIO);                       \
  HAL_ARM_AT91_GPIOX_SET(_pin_, 1, AT91_PIOB);                      \
  HAL_ARM_AT91_GPIOX_SET(_pin_, 2, AT91_PIOC);                      \
  CYG_MACRO_END

// Reset a GPIO pin to 0
#define HAL_ARM_AT91_GPIO_RESET(_pin_)                              \
  CYG_MACRO_START                                                   \
  HAL_ARM_AT91_GPIOX_RESET(_pin_, 0, AT91_PIO);                     \
  HAL_ARM_AT91_GPIOX_RESET(_pin_, 1, AT91_PIOB);                    \
  HAL_ARM_AT91_GPIOX_RESET(_pin_, 2, AT91_PIOC);                    \
  CYG_MACRO_END

// Configure a GPIO pin to generate interrupts
#define HAL_ARM_AT91_GPIO_GET(_pin_, _value_)                        \
  CYG_MACRO_START                                                    \
  HAL_ARM_AT91_GPIOX_GET(_pin_, _value_, 0, AT91_PIO);               \
  HAL_ARM_AT91_GPIOX_GET(_pin_, _value_, 1, AT91_PIOB);              \
  HAL_ARM_AT91_GPIOX_GET(_pin_, _value_, 2, AT91_PIOC);              \
  CYG_MACRO_END


#elif defined( AT91_PIOB )
//====================================================================
// 					Two PIO controllers
//====================================================================

// Configure a peripheral pin for peripheral operation
#define HAL_ARM_AT91_PIO_CFG(_pin_)             					\
  CYG_MACRO_START                               					\
  HAL_ARM_AT91_PIOX_CFG(_pin_, 0, AT91_PIO);        				\
  HAL_ARM_AT91_PIOX_CFG(_pin_, 1, AT91_PIOB);       				\
CYG_MACRO_END

// Configure a GPIO pin direction
#define HAL_ARM_AT91_GPIO_CFG_DIRECTION(_pin_, _dir_)            	\
  CYG_MACRO_START                                                	\
  HAL_ARM_AT91_GPIOX_CFG_DIRECTION(_pin_, _dir_, 0, AT91_PIO);   	\
  HAL_ARM_AT91_GPIOX_CFG_DIRECTION(_pin_, _dir_, 1, AT91_PIOB);  	\
  CYG_MACRO_END

// Configure a GPIO pin pullup resistor
#define HAL_ARM_AT91_GPIO_CFG_PULLUP(_pin_, _enable_)               \
  CYG_MACRO_START                                                   \
  HAL_ARM_AT91_GPIOX_CFG_PULLUP(_pin_, _enable_, 0, AT91_PIO);      \
  HAL_ARM_AT91_GPIOX_CFG_PULLUP(_pin_, _enable_, 1, AT91_PIOB);     \
  CYG_MACRO_END

// Configure a GPIO pin to generate interrupts
#define HAL_ARM_AT91_GPIO_CFG_INTERRUPT(_pin_, _enable_)            \
  CYG_MACRO_START                                                   \
  HAL_ARM_AT91_GPIOX_CFG_INTERRUPT(_pin_, _enable_, 0, AT91_PIO);   \
  HAL_ARM_AT91_GPIOX_CFG_INTERRUPT(_pin_, _enable_, 1, AT91_PIOB);  \
  CYG_MACRO_END

// Set a GPIO pin to 1
#define HAL_ARM_AT91_GPIO_SET(_pin_)                                \
  CYG_MACRO_START                                                   \
  HAL_ARM_AT91_GPIOX_SET(_pin_, 0, AT91_PIO);                       \
  HAL_ARM_AT91_GPIOX_SET(_pin_, 1, AT91_PIOB);                      \
  CYG_MACRO_END

// Reset a GPIO pin to 0
#define HAL_ARM_AT91_GPIO_RESET(_pin_)                              \
  CYG_MACRO_START                                                   \
  HAL_ARM_AT91_GPIOX_RESET(_pin_, 0, AT91_PIO);                     \
  HAL_ARM_AT91_GPIOX_RESET(_pin_, 1, AT91_PIOB);                    \
  CYG_MACRO_END

// Configure a GPIO pin to generate interrupts
#define HAL_ARM_AT91_GPIO_GET(_pin_, _value_)                        \
  CYG_MACRO_START                                                    \
  HAL_ARM_AT91_GPIOX_GET(_pin_, _value_, 0, AT91_PIO);               \
  HAL_ARM_AT91_GPIOX_GET(_pin_, _value_, 1, AT91_PIOB);              \
  CYG_MACRO_END

#else
//====================================================================
// 					One PIO controller
//====================================================================
// Only one PIO controller

// Configure a peripheral pin for peripheral operation
#define HAL_ARM_AT91_PIO_CFG(_pin_)             					\
  CYG_MACRO_START                               					\
  HAL_ARM_AT91_PIOX_CFG(_pin_, 0, AT91_PIO);    					\
  CYG_MACRO_END

// Configure a GPIO pin direction
#define HAL_ARM_AT91_GPIO_CFG_DIRECTION(_pin_, _dir_)            	\
  CYG_MACRO_START                                                	\
  HAL_ARM_AT91_GPIOX_CFG_DIRECTION(_pin_, _dir_, 0, AT91_PIO);   	\
  CYG_MACRO_END

// Configure a GPIO pin pullup resistor
#define HAL_ARM_AT91_GPIO_CFG_PULLUP(_pin_, _enable_)               \
  CYG_MACRO_START                                                   \
  HAL_ARM_AT91_GPIOX_CFG_PULLUP(_pin_, _enable_, 0, AT91_PIO);      \
  CYG_MACRO_END

// Configure a GPIO pin to generate interrupts
#define HAL_ARM_AT91_GPIO_CFG_INTERRUPT(_pin_, _enable_)            \
  CYG_MACRO_START                                                   \
  HAL_ARM_AT91_GPIOX_CFG_INTERRUPT(_pin_, _enable_, 0, AT91_PIO);   \
  CYG_MACRO_END

// Configure a GPIO pin to generate interrupts
#define HAL_ARM_AT91_GPIO_SET(_pin_)                                \
  CYG_MACRO_START                                                   \
  HAL_ARM_AT91_GPIOX_SET(_pin_, 0, AT91_PIO);                       \
  CYG_MACRO_END

// Configure a GPIO pin to generate interrupts
#define HAL_ARM_AT91_GPIO_RESET(_pin_)                              \
  CYG_MACRO_START                                                   \
  HAL_ARM_AT91_GPIOX_RESET(_pin_, 0, AT91_PIO);                     \
  CYG_MACRO_END

// Configure a GPIO pin to generate interrupts
#define HAL_ARM_AT91_GPIO_GET(_pin_, _value_)                       \
  CYG_MACRO_START                                                   \
  HAL_ARM_AT91_GPIOX_GET(_pin_, _value_, 0, AT91_PIO);              \
  CYG_MACRO_END


#endif



// Put a GPIO pin to a given state
#define HAL_ARM_AT91_GPIO_PUT(_pin_, _state_)   					\
  	CYG_MACRO_START                               					\
  	if (_state_)													\
  	{                                								\
    	HAL_ARM_AT91_GPIO_SET(_pin_);               				\
  	} 																\
  	else 															\
  	{                                      							\
    	HAL_ARM_AT91_GPIO_RESET(_pin_);             				\
  	}                                             					\
  	CYG_MACRO_END

 
//-----------------------------------------------------------------------------
// end of var_io.h
#endif // CYGONCE_HAL_VAR_IO_H
