#ifndef CYGONCE_HAL_VAR_SAM9_H
#define CYGONCE_HAL_VAR_SAM9_H
//=============================================================================
//
//      var_sam9.h
//
//      Variant specific registers for Atmel AT91SAM9
//
//=============================================================================
//####ECOSGPLCOPYRIGHTBEGIN####
// -------------------------------------------
// This file is part of eCos, the Embedded Configurable Operating System.
// Copyright (C) 1998, 1999, 2000, 2001, 2002 Red Hat, Inc.
// Copyright (C) 2003 Nick Garnett <nickg@calivar.com>
// Copyright (C) 2005, 2006 Andrew Lunn (andrew.lunn@ascom.ch>
//
// eCos is free software; you can redistribute it and/or modify it under
// the terms of the GNU General Public License as published by the Free
// Software Foundation; either version 2 or (at your option) any later version.
//
// eCos is distributed in the hope that it will be useful, but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or
// FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
// for more details.
//
// You should have received a copy of the GNU General Public License along
// with eCos; if not, write to the Free Software Foundation, Inc.,
// 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.
//
// As a special exception, if other files instantiate templates or use macros
// or inline functions from this file, or you compile this file and link it
// with other works to produce a work based on this file, this file does not
// by itself cause the resulting work to be covered by the GNU General Public
// License. However the source code for this file must still be made available
// in accordance with section (3) of the GNU General Public License.
//
// This exception does not invalidate any other reasons why a work based on
// this file might be covered by the GNU General Public License.
// -------------------------------------------
//####ECOSGPLCOPYRIGHTEND####
//=============================================================================
//#####DESCRIPTIONBEGIN####
//
// Author(s):   ilko iliev
// Contributors:
// Date:        2006-08-24
// Purpose:     AT91SAM9 variant specific registers
// Description: This file is included from var_io.h
// Usage:       #include "var_sam9.h"
//
//####DESCRIPTIONEND####
//
//=============================================================================


//=============================================================================
// Advanced Interrupt Controller (AIC)
//=============================================================================
#ifndef AT91_AIC
#define AT91_AIC      				0xFFFFF000
#endif
#define AT91_AIC_IVR    			0x100
#define AT91_AIC_FVR    			0x104
#define AT91_AIC_ISR    			0x108
#define AT91_AIC_IPR    			0x10C
#define AT91_AIC_IMR    			0x110
#define AT91_AIC_CISR   			0x114
#define AT91_AIC_IECR   			0x120
#define AT91_AIC_IDCR   			0x124
#define AT91_AIC_ICCR   			0x128
#define AT91_AIC_ISCR   			0x12C
#define AT91_AIC_EOI    			0x130
#define AT91_AIC_SVR    			0x134
#define AT91_AIC_DCR    			0x138 		// Debug Control Register
#define AT91_AIC_FFER   			0x140 		// Fast Forcing Enable Register
#define AT91_AIC_FFDR   			0x144 		// Fast Forcing Enable Register
#define AT91_AIC_FFSR   			0x148 		// Fast Forcing Enable Register
#define AT91_AIC_SMR0   			((0*4)+0x000)
  #define AT91_AIC_SMR_LEVEL_LOW  	(0<<5)
  #define AT91_AIC_SMR_LEVEL_HI   	(2<<5)
  #define AT91_AIC_SMR_EDGE_NEG   	(1<<5)
  #define AT91_AIC_SMR_EDGE_POS   	(3<<5)
  #define AT91_AIC_SMR_PRIORITY   	0x07


//=============================================================================
// Periodic Interval Timer Controller
//=============================================================================
#ifndef AT91_PITC
#define AT91_PITC 					0xfffffd30
#endif
#define AT91_PITC_PIMR 				0x00  		// Period Interval Mode Register
  #define AT91_PITC_PIMR_PITEN  	(1 << 24) 	// Periodic Interval Timer Enable
  #define AT91_PITC_PIMR_PITIEN 	(1 << 25) 	// Periodic Interval Timer Interrupt Enable
#define AT91_PITC_PISR 				0x04  		// Period Interval Status Register
 #define AT91_PITC_PISR_PITS   		(1 << 0)  	// Periodic Interval Timer Status
#define AT91_PITC_PIVR 				0x08  		// Period Interval Status Register
#define AT91_PITC_PIIR 				0x0C  		// Period Interval Image Register



//=============================================================================
// Debug Unit
//=============================================================================
#ifndef AT91_DBG
#define AT91_DBG 					0xFFFFF200
#endif
#define AT91_DBG_CR   				0x00 		// Control Register
  #define AT91_DBG_CR_RSTRX  		(0x1 << 2)  // Reset Receiver
  #define AT91_DBG_CR_RSTTX  		(0x1 << 3)  // Reset Transmitter
  #define AT91_DBG_CR_RXEN   		(0x1 << 4)  // Receiver Enable
  #define AT91_DBG_CR_RXDIS  		(0x1 << 5)  // Receiver Disable
  #define AT91_DBG_CR_TXEN   		(0x1 << 6)  // Transmitter Enable
  #define AT91_DBG_CR_TXDIS  		(0x1 << 7)  // Transmitter Disable
  #define AT91_DBG_CR_RSTSTA 		(0x1 << 8)  // Reset Status Bits
#define AT91_DBG_MR   				0x04 		// Mode Register
  #define AT91_DBG_MR_PAR_EVEN  	(0x0 << 9) 	// Even Parity
  #define AT91_DBG_MR_PAR_ODD   	(0x1 << 9) 	// Odd Parity
  #define AT91_DBG_MR_PAR_SPACE 	(0x2 << 9) 	// Parity forced to Space
  #define AT91_DBG_MR_PAR_MARK  	(0x3 << 9) 	// Parity forced to Mark
  #define AT91_DBG_MR_PAR_NONE  	(0x4 << 9) 	// No Parity
  #define AT91_DBG_MR_PAR_MULTI 	(0x6 << 9) 	// Multi-drop mode
  #define AT91_DBG_MR_CHMODE_NORMAL (0x0 << 14) // Normal mode
  #define AT91_DBG_MR_CHMODE_AUTO   (0x1 << 14) // Automatic Echo
  #define AT91_DBG_MR_CHMODE_LOCAL  (0x2 << 14) // Local Loopback
  #define AT91_DBG_MR_CHMODE_REMOTE (0x3 << 14) // Remote Loopback
#define AT91_DBG_IER  				0x08 		// Interrupt Enable Register
#define AT91_DBG_IDR  				0x0c 		// Interrupt Disable Register
#define AT91_DBG_IMR  				0x10 		// Interrupt Mask Register
#define AT91_DBG_CSR  				0x14 		// Channel Status Register
  #define AT91_DBG_CSR_RXRDY  		(1 << 0) 	// Receiver Ready
  #define AT91_DBG_CSR_TXRDY  		(1 << 1) 	// Transmitter Ready
#define AT91_DBG_RHR  				0x18 		// Receiver Holding Register
#define AT91_DBG_THR  				0x1c 		// Transmitter Holding Register
#define AT91_DBG_BRGR 				0x20 		// Baud Rate Generator Register
#define AT91_DBG_FNTR 				0x48 		// Force NTRST Register
#define AT91_DBG_RPR  				0x100 		// Receiver Pointer Register
#define AT91_DBG_RCR  				0x104 		// Receiver Counter Register
#define AT91_DBG_TPR  				0x108 		// Transmit Pointer Register
#define AT91_DBG_TCR  				0x10c 		// Transmit Counter Register
#define AT91_DBG_RNPR 				0x110 		// Receiver Next Pointer Register
#define AT91_DBG_RNCR 				0x114 		// Receiver Next Counter Register
#define AT91_DBG_TNPR 				0x118 		// Transmit Next Pointer Register
#define AT91_DBG_TNCR 				0x11c 		// Transmit Next Counter Register
#define AT91_DBG_PTCR 				0x120 		// PDC Transfer Control Register
#define AT91_DBG_PTSR 				0x124 		// PDC Transfer Status Register



//=============================================================================
// Real Time Timer Controller
//=============================================================================
#ifndef AT91_RTTC
#define AT91_RTTC 					0xFFFFFD20
#endif
#define AT91_RTTC_RTMR 				0x00 		// Real Time Mode Register
  #define AT91_RTTC_RTMR_ALMIEN    	(1 << 16) 	// Alarm Interrupt Enable
  #define AT91_RTTC_RTMR_RTTINCIEN 	(1 << 17) 	// Timer Increment Interrupt Enable
  #define AT91_RTTC_RTMR_RTTRST    	(1 << 18) 	// Timer Reset
#define AT91_RTTC_RTAR 				0x04 		// Real Time Alarm Register
#define AT91_RTTC_RTVR 				0x08 		// Real Time Value Register
#define AT91_RTTC_RTSR 				0x0C 		// Real Time Status Register
  #define AT91_RTTC_RTSR_ALMS     	(1 << 0) 	// Alarm Status
  #define AT91_RTTC_RTSR_RTTINC   	(1 << 1) 	// Timer Increment



//=============================================================================
// Watchdog Timer Controller
//=============================================================================
#ifndef AT91_WDTC
#define AT91_WDTC 					0xFFFFFD40
#endif
#define AT91_WDTC_WDCR 				0x00 		// Watchdog Control Register
  #define AT91_WDTC_WDCR_RELOAD  	(1 << 0)  	// Reload the watchdog
  #define AT91_WDTC_WDCR_KEY    	(0xa5 << 24) // Password for the write op
#define AT91_WDTC_WDMR 				0x04 		// Watchdog Mode Register
  #define AT91_WDTC_WDMR_FIEN    	(1 << 12) 	// Fault Interrupt Mode Enable
  #define AT91_WDTC_WDMR_RSTEN   	(1 << 13) 	// Reset Enable
  #define AT91_WDTC_WDMR_RPROC   	(1 << 14) 	// Trigger a processor reset
  #define AT91_WDTC_WDMR_DIS     	(1 << 15) 	// Disable
  #define AT91_WDTC_WDMR_WDD_SHIFT 	(1 << 16)   // Delta Value shift, 12-bit value
  #define AT91_WDTC_WDMR_DBGHLT  	(1 << 28) 	// Stop when in debug state
  #define AT91_WDTC_WDMR_IDLEHLT 	(1 << 29) 	// Stop when in idle more
#define AT91_WDTC_WDSR 				0x08 		// Watchdog Status Register
  #define AT91_WDTC_WDSR_UNDER   	(1 << 0)  	// Underflow has occurred
  #define AT91_WDTC_WDSR_ERROR   	(1 << 1)  	// Error has occurred


//=============================================================================
// Reset Controller
//=============================================================================
#ifndef AT91_RST
#define AT91_RST 					0xFFFFFD00
#endif

#define AT91_RST_RCR 				0x00 		// Reset Control Register
  #define AT91_RST_RCR_PROCRST  	(1 << 0) 	// Processor Reset
  #define AT91_RST_RCR_ICERST   	(1 << 1) 	// ICE Reset
  #define AT91_RST_RCR_PERRST   	(1 << 2) 	// Peripheral Reset
  #define AT91_RST_RCR_EXTRST   	(1 << 3) 	// External Reset
  #define AT91_RST_RCR_KEY      	(0xA5 << 24) // Key

#define AT91_RST_RSR 				0x04 		// Reset Status Register
  #define AT91_RST_RSR_USER          (1 << 0) 	// User Reset
  #define AT91_RST_RSR_BROWN         (1 << 1) 	// Brownout detected
  #define AT91_RST_RSR_TYPE_POWERUP  (0 << 8) 	// Power on Reset
  #define AT91_RST_RSR_TYPE_WATCHDOG (2 << 8) 	// Watchdog Reset
  #define AT91_RST_RSR_TYPE_SW       (3 << 8) 	// Software Reset
  #define AT91_RST_RSR_TYPE_USER     (4 << 8) 	// NRST pin Reset
  #define AT91_RST_RSR_TYPE_BROWNOUT (5 << 8) 	// Brown-out Reset
  #define AT91_RST_RSR_NRST_SET 	 (1 << 16) 	// NRST pin set
  #define AT91_RST_RSR_SRCMP    	 (1 << 17) 	// Software reset in progress
  
#define AT91_RST_RMR 				0x08 		// Reset Mode Register
  #define AT91_RST_RMR_URSTEN  		(1 << 0)  	// User Reset Enabled
  #define AT91_RST_RMR_URSTIEN 		(1 << 4)  	// User Reset Interrupt Enabled
  #define AT91_RST_RMR_BODIEN  		(1 << 16) 	// Brownout Dection Interrupt Enabled
  #define AT91_RST_RMR_KEY     		(0xA5 << 24) // Key


//=============================================================================
// UART Controller
//=============================================================================
#define	AT91_USART0					0xFFFB0000
#define	AT91_USART1					0xFFFB4000
#define	AT91_USART2					0xFFFB8100

#define AT91_US_CR  				0x00  		// Control register
  #define AT91_US_CR_RxRESET 		(1<<2)
  #define AT91_US_CR_TxRESET 		(1<<3)
  #define AT91_US_CR_RxENAB  		(1<<4)
  #define AT91_US_CR_RxDISAB 		(1<<5)
  #define AT91_US_CR_TxENAB  		(1<<6)
  #define AT91_US_CR_TxDISAB 		(1<<7)
  #define AT91_US_CR_RSTATUS 		(1<<8)
  #define AT91_US_CR_STTTO   		(1<<11)
  
#define AT91_US_MR  				0x04  		// Mode register
  #define AT91_US_MR_CLOCK   		4
  #define AT91_US_MR_CLOCK_MCK  	(0<<AT91_US_MR_CLOCK)
  #define AT91_US_MR_CLOCK_MCK8 	(1<<AT91_US_MR_CLOCK)
  #define AT91_US_MR_CLOCK_SCK  	(2<<AT91_US_MR_CLOCK)
  #define AT91_US_MR_LENGTH  		6
  #define AT91_US_MR_LENGTH_5   	(0<<AT91_US_MR_LENGTH)
  #define AT91_US_MR_LENGTH_6   	(1<<AT91_US_MR_LENGTH)
  #define AT91_US_MR_LENGTH_7   	(2<<AT91_US_MR_LENGTH)
  #define AT91_US_MR_LENGTH_8   	(3<<AT91_US_MR_LENGTH)
  #define AT91_US_MR_SYNC    		8
  #define AT91_US_MR_SYNC_ASYNC 	(0<<AT91_US_MR_SYNC)
  #define AT91_US_MR_SYNC_SYNC  	(1<<AT91_US_MR_SYNC)
  #define AT91_US_MR_PARITY  		9
  #define AT91_US_MR_PARITY_EVEN  	(0<<AT91_US_MR_PARITY)
  #define AT91_US_MR_PARITY_ODD   	(1<<AT91_US_MR_PARITY)
  #define AT91_US_MR_PARITY_SPACE 	(2<<AT91_US_MR_PARITY)
  #define AT91_US_MR_PARITY_MARK  	(3<<AT91_US_MR_PARITY)
  #define AT91_US_MR_PARITY_NONE  	(4<<AT91_US_MR_PARITY)
  #define AT91_US_MR_PARITY_MULTI 	(6<<AT91_US_MR_PARITY)
  #define AT91_US_MR_STOP   		12
  #define AT91_US_MR_STOP_1       	(0<<AT91_US_MR_STOP)
  #define AT91_US_MR_STOP_1_5     	(1<<AT91_US_MR_STOP)
  #define AT91_US_MR_STOP_2       	(2<<AT91_US_MR_STOP)
  #define AT91_US_MR_MODE   		14
  #define AT91_US_MR_MODE_NORMAL  	(0<<AT91_US_MR_MODE)
  #define AT91_US_MR_MODE_ECHO    	(1<<AT91_US_MR_MODE)
  #define AT91_US_MR_MODE_LOCAL   	(2<<AT91_US_MR_MODE)
  #define AT91_US_MR_MODE_REMOTE  	(3<<AT91_US_MR_MODE)
  #define AT91_US_MR_MODE9  		17
  #define AT91_US_MR_CLKO   		18
  
#define AT91_US_IER 				0x08  	// Interrupt enable register
  #define AT91_US_IER_RxRDY   		(1<<0)  // Receive data ready
  #define AT91_US_IER_TxRDY   		(1<<1)  // Transmitter ready
  #define AT91_US_IER_RxBRK   		(1<<2)  // Break received
  #define AT91_US_IER_ENDRX   		(1<<3)  // Rx end
  #define AT91_US_IER_ENDTX   		(1<<4)  // Tx end
  #define AT91_US_IER_OVRE    		(1<<5)  // Rx overflow
  #define AT91_US_IER_FRAME   		(1<<6)  // Rx framing error
  #define AT91_US_IER_PARITY  		(1<<7)  // Rx parity
  #define AT91_US_IER_TIMEOUT 		(1<<8)  // Rx timeout
  #define AT91_US_IER_TxEMPTY 		(1<<9)  // Tx empty
  
#define AT91_US_IDR 				0x0C  	// Interrupt disable register
#define AT91_US_IMR 				0x10  	// Interrupt mask register
#define AT91_US_CSR 				0x14  	// Channel status register
  #define AT91_US_CSR_RxRDY 		0x01 	// Receive data ready
  #define AT91_US_CSR_TxRDY 		0x02 	// Transmit ready
  #define AT91_US_CSR_RXBRK 		0x04 	// Transmit ready
  #define AT91_US_CSR_ENDRX 		0x08 	// Transmit ready
  #define AT91_US_CSR_ENDTX			0x10 	// Transmit ready
  #define AT91_US_CSR_OVRE  		0x20 	// Overrun error
  #define AT91_US_CSR_FRAME 		0x40 	// Framing error
  #define AT91_US_CSR_TIMEOUT 		0x80 	// Timeout
  
#define AT91_US_RHR 				0x18  	// Receive holding register
#define AT91_US_THR 				0x1C  	// Transmit holding register
#define AT91_US_BRG 				0x20  	// Baud rate generator
#define AT91_US_RTO 				0x24  	// Receive time out
#define AT91_US_TTG 				0x28  	// Transmit timer guard
#define AT91_US_RPR 				0x100  	// Receive pointer register
#define AT91_US_RCR 				0x104  	// Receive counter register
#define AT91_US_TPR 				0x108  	// Transmit pointer register
#define AT91_US_TCR 				0x10c  	// Transmit counter register


#ifndef AT91_US_BAUD
#define AT91_US_BAUD(baud) ((CYGNUM_HAL_ARM_AT91_CLOCK_SPEED/(8*(baud))+1)/2)
#endif


//=============================================================================
// (Advanced) Power Management
//=============================================================================
#ifndef AT91_PMC
#define AT91_PMC        			0xFFFFFC00
#endif
#define AT91_PMC_SCDR           	0x04
#define	AT91_PMC_PCER				0x10
#define AT91_PMC_PCDR				0x14
#define AT91_PMC_IMR				0x6C
#define AT91_PMC_SR					0x68
  #define AT91_PMC_SR_MOSCS   		(1 << 0) 		// Main oscillator stable
  #define AT91_PMC_SR_LOCKA    		(1 << 1) 		// PLL Locked
  #define AT91_PMC_SR_LOCKB    		(1 << 2) 		// PLL Locked
  #define AT91_PMC_SR_LOCK    		AT91_PMC_SR_LOCKA
  #define AT91_PMC_SR_MCKRDY  		(1 << 3) 		// MCK is ready to be enabled
  #define AT91_PMC_SR_PCK0RDY 		(1 << 8) 		// Pad clock 0 is ready to be enabled
  #define AT91_PMC_SR_PCK1RDY 		(1 << 9) 		// Pad clock 1 is ready to be enabled
  #define AT91_PMC_SR_PCK2RDY 		(1 << 10) 		// Pad clock 2 is ready to be enabled
  #define AT91_PMC_SR_PCK3RDY 		(1 << 11) 		// Pad clock 3 is ready to be enabled
	
#define AT91_PMC_MCKR 				0x30 			// Master Clock Register
  #define AT91_PMC_MCKR_SLOW_CLK 	0 				// Slow clock selected
  #define AT91_PMC_MCKR_MAIN_CLK 	1 				// Main clock selected
  #define AT91_PMC_MCKR_PLL_CLK 	2 				// PLLA clock selected
  #define AT91_PMC_MCKR_PLLB_CLK 	3 				// PLLB clock selected



//=============================================================================
// PIO Controller
//=============================================================================
#ifndef AT91_PIO
#define AT91_PIO      				0xFFFFF400		// PIOA
#define AT91_PIOA      				0xFFFFF400		// PIOA
#define AT91_PIOB      				0xFFFFF600		// PIOB
#define AT91_PIOC      				0xFFFFF800		// PIOC
#endif
#define AT91_PIO_PER  				0x00  			// PIO enable
#define AT91_PIO_PDR  				0x04  			// PIO disable
#define AT91_PIO_PSR  				0x08  			// PIO status
  #define AT91_PIO_PSR_DRXD			(1 << 9)		// used in hal_diag_dbg.c 
  #define AT91_PIO_PSR_DTXD			(1 << 10)
#define AT91_PIO_OER  				0x10  			// Output enable
#define AT91_PIO_ODR  				0x14  			// Output disable
#define AT91_PIO_OSR  				0x18  			// Output status
#define AT91_PIO_IFER 				0x20  			// Input Filter enable
#define AT91_PIO_IFDR 				0x24  			// Input Filter disable
#define AT91_PIO_IFSR 				0x28  			// Input Filter status
#define AT91_PIO_SODR 				0x30  			// Set out bits
#define AT91_PIO_CODR 				0x34  			// Clear out bits
#define AT91_PIO_ODSR 				0x38  			// Output data status
#define AT91_PIO_PDSR 				0x3C  			// Pin data status
#define AT91_PIO_IER  				0x40  			// Interrupt enable
#define AT91_PIO_IDR  				0x44  			// Interrupt disable
#define AT91_PIO_IMR  				0x48  			// Interrupt mask
#define AT91_PIO_ISR  				0x4C  			// Interrupt status
#define AT91_PIO_MDER  				0x50  			// Multi-drive Enable Register
#define AT91_PIO_MDDR  				0x54  			// Multi-drive Disable Register
#define AT91_PIO_MDSR  				0x58  			// Multi-drive Status Register
#define AT91_PIO_PPUDR 				0x60  			// Pad Pull-up Disable Register 																								
#define AT91_PIO_PPUER 				0x64  			// Pad Pull-up Enable Register  																								
#define AT91_PIO_PPUSR 				0x68  			// Pad Pull-Up Status Register  																								
#define AT91_PIO_ASR   				0x70  			// Select A Register            																								
#define AT91_PIO_BSR   				0x74  			// Select B Regsiter            																								
#define AT91_PIO_ABS   				0x78  			// AB Select Regsiter           																								
#define AT91_PIO_OWER  				0xa0  			// Output Write Enable Register 																								
#define AT91_PIO_OWDR  				0xa4  			// Output Write Disable Register																								
#define AT91_PIO_OWSR  				0xa8  			// Output Write Status Register 																								



//=============================================================================
// Timer / counter
//=============================================================================
#ifndef AT91_TC
#define AT91_TC         			0xFFFA0000		// TC0
#endif

#define AT91_TC_TC0     			0x00
#define AT91_TC_CCR     			0x00
  #define AT91_TC_CCR_CLKEN  		0x01
  #define AT91_TC_CCR_CLKDIS 		0x02
  #define AT91_TC_CCR_TRIG   		0x04
  
#define AT91_TC_CMR		   			0x04
  #define AT91_TC_CMR_CLKS	   		0
  #define AT91_TC_CMR_CLKS_MCK2     (0<<0)
  #define AT91_TC_CMR_CLKS_MCK8     (1<<0)
  #define AT91_TC_CMR_CLKS_MCK32    (2<<0)
  #define AT91_TC_CMR_CPCTRG	   	(1<<14)
  
#define AT91_TC_CV      			0x10
#define AT91_TC_RA      			0x14
#define AT91_TC_RB      			0x18
#define AT91_TC_RC      			0x1C

#define AT91_TC_SR      			0x20
  #define AT91_TC_SR_COVF    		(1<<0)  	// Counter overrun            																														
  #define AT91_TC_SR_LOVR    		(1<<1)  	// Load overrun               																														
  #define AT91_TC_SR_CPA     		(1<<2)  	// RA compare                 																														
  #define AT91_TC_SR_CPB     		(1<<3)  	// RB compare                 																														
  #define AT91_TC_SR_CPC     		(1<<4)  	// RC compare                 																														
  #define AT91_TC_SR_LDRA    		(1<<5)  	// Load A status              																														
  #define AT91_TC_SR_LDRB    		(1<<6)  	// Load B status              																														
  #define AT91_TC_SR_EXT     		(1<<7)  	// External trigger 
  
#define AT91_TC_IDR     			0x28
#define AT91_TC_IMR     			0x2C
#define AT91_TC_TC1     			0x40
#define AT91_TC_TC2     			0x80
#define AT91_TC_BCR     			0xC0
#define AT91_TC_IER     			0x24
  #define AT91_TC_IER_CPC    		(1<<4)  	// RC compare


//=============================================================================
// UDP
//=============================================================================
#ifndef AT91_UDP
#define AT91_UDP 					0xFFFA4000
#endif

#define AT91_UDP_FRM_NUM    		0x00  		// Frame Number
#define AT91_UDP_FRM_ERR     		(1 << 16) 	// Frame Error
#define AT91_UDP_FRM_OK      		(1 << 17) 	// Frame OK
#define AT91_UDP_GLB_STATE  		0x04  		// Global State
#define AT91_UDP_GLB_FADDEN  		(1 <<  0) 	// Function Address Enable
#define AT91_UDP_GLB_CONFG   		(1 <<  1) 	// Configured
#define AT91_UDP_GLB_ESR     		(1 <<  2) 	// Enable Send Resume
#define AT91_UDP_GLB_RSMINPR 		(1 <<  3) 	// A Resume has been seen
#define AT91_UDP_GLB_RMWUPE  		(1 <<  4) 	// Remote Wake Up Enable
#define AT91_UDP_FADDR      		0x08  		// Function Address
#define AT91_UDP_FADDR_FEN   		(1 <<  8) 	// Function Enable
#define AT91_UDP_IER        		0x10  		// Interrupt Enable
  #define AT91_UDP_EPINT0      		(1 <<  0) 	// Endpoint 0 Interrupt
  #define AT91_UDP_EPINT1      		(1 <<  1) 	// Endpoint 1 Interrupt
  #define AT91_UDP_EPINT2      		(1 <<  2) 	// Endpoint 2 Interrupt
  #define AT91_UDP_EPINT3      		(1 <<  3) 	// Endpoint 3 Interrupt
  #define AT91_UDP_EPINT4      		(1 <<  4) 	// Endpoint 4 Interrupt
  #define AT91_UDP_EPINT5      		(1 <<  5) 	// Endpoint 5 Interrupt
  #define AT91_UDP_EPINT6      		(1 <<  6) 	// Endpoint 6 Interrupt
  #define AT91_UDP_EPINT7      		(1 <<  7) 	// Endpoint 7 Interrupt
  #define AT91_UDP_RXSUSP      		(1 <<  8) 	// USB Suspend Interrupt
  #define AT91_UDP_RXRSM       		(1 <<  9) 	// USB Resume Interrupt
  #define AT91_UDP_EXTRSM      		(1 << 10) 	// USB External Resume Interrupt
  #define AT91_UDP_SOFINT      		(1 << 11) 	// USB start of frame Interrupt
  #define AT91_UDP_ENDBUSRES   		(1 << 12) 	// USB End of Bus Reset Interrupt
  #define AT91_UDP_WAKEUP      		(1 << 13) 	// USB Resume Interrupt
#define AT91_UDP_IDR        		0x14  		// Interrupt Disable
#define AT91_UDP_IMR        		0x18  		// Interrupt Mask
#define AT91_UDP_ISR        		0x1C  		// Interrupt Status
#define AT91_UDP_ICR        		0x20  		// Interrupt Clear
#define AT91_UDP_RST_EP     		0x28  		// Reset Endpoint
#define AT91_UDP_CSR        		0x30  		// Endpoint Control and Status
  #define AT91_UDP_CSR_TXCOMP     	(1 <<  0) 	// Generates an IN packet
  #define AT91_UDP_CSR_RX_DATA_BK0 	(1 <<  1) 	// Receive Data Bank 0
  #define AT91_UDP_CSR_RXSETUP     	(1 <<  2) 	// Sends a STALL to the host
  #define AT91_UDP_CSR_ISOERROR    	(1 <<  3) 	// Isochronous error
  #define AT91_UDP_CSR_TXPKTRDY    	(1 <<  4) 	// Transmit Packet Ready
  #define AT91_UDP_CSR_FORCESTALL  	(1 <<  5) 	// Force Stall
  #define AT91_UDP_CSR_RX_DATA_BK1 	(1 <<  6) 	// Receive Data Bank 1
  #define AT91_UDP_CSR_DIR         	(1 <<  7) 	// Transfer Direction
  #define AT91_UDP_CSR_DIR_OUT     	(0 <<  7) 	// Transfer Direction OUT
  #define AT91_UDP_CSR_DIR_IN      	(1 <<  7) 	// Transfer Direction IN
  #define AT91_UDP_CSR_EPTYPE_CTRL     (0 << 8) // Control
  #define AT91_UDP_CSR_EPTYPE_ISO_OUT  (1 << 8) // Isochronous OUT
  #define AT91_UDP_CSR_EPTYPE_BULK_OUT (2 << 8) // Bulk OUT
  #define AT91_UDP_CSR_EPTYPE_INT_OUT  (3 << 8) // Interrupt OUT
  #define AT91_UDP_CSR_EPTYPE_ISO_IN   (5 << 8) // Isochronous IN
  #define AT91_UDP_CSR_EPTYPE_BULK_IN  (6 << 8) // Bulk IN
  #define AT91_UDP_CSR_EPTYPE_INT_IN   (7 << 8) // Interrupt IN
  #define AT91_UDP_CSR_DTGLE       	(1 << 11) 	// Data Toggle
  #define AT91_UDP_CSR_EPEDS       	(1 << 15) 	// Endpoint Enable Disable
#define AT91_UDP_FDR        		0x50  		// Endpoint FIFO Data
#define AT91_UDP_TXVC       		0x74  		// Transceiver Control
  #define AT91_UDP_TXVC_TXVDIS     	(1 <<  8) 	// Disable Transceiver
  #define AT91_UDP_TXVC_PUON       	(1 <<  9) 	// Pull-up ON


//=============================================================================
// SPI
//=============================================================================
#ifndef AT91_SPI
#define AT91_SPI               		0xFFFC8000
#define AT91_SPI1              		0xFFFCC000
#endif

#define AT91_SPI_CR            		0x00              // Control Register 
  #define AT91_SPI_CR_SPIEN      	0x00000001        // SPI Enable
  #define AT91_SPI_CR_SPIDIS     	0x00000002        // SPI Disable
  #define AT91_SPI_CR_SWRST      	0x00000080        // SPI Software reset

#define AT91_SPI_MR            		0x04              // Mode Register
  #define AT91_SPI_MR_MSTR       	0x00000001        // Master/Slave Mode 
  #define AT91_SPI_MR_PS         	0x00000002        // Peripheral Select
  #define AT91_SPI_MR_PCSDEC     	0x00000004        // Chip Select Decode
  #define AT91_SPI_MR_DIV32      	0        		  // not available in AT91SAM9261
  #define AT91_SPI_MR_LLB        	0x00000080        // Local Loopback Enable
  #define AT91_SPI_MR_MODFDIS		0x10			  // 0 - Mode fault detection enabled, 1 - disabled
  #define AT91_SPI_MR_PCS(x)     	(((x)&0x0F)<<16)  // Peripheral Chip Select
  #define AT91_SPI_MR_DLYBCS(x)  	(((x)&0xFF)<<24)  // Delay Between Chip Selects
	
#define AT91_SPI_RDR           		0x08              // Receive Data Register
#define AT91_SPI_TDR           		0x0C              // Transmit Data Register

#define AT91_SPI_SR            		0x10              // Status Register
	#define AT91_SPI_SR_RDRF       	0x00000001        // Receive Data Register Full
	#define AT91_SPI_SR_TDRE       	0x00000002        // Tx Data Register Empty
	#define AT91_SPI_SR_MODF       	0x00000004        // Mode Fault Error
	#define AT91_SPI_SR_OVRES      	0x00000008        // Overrun Error Status
	#define AT91_SPI_SR_ENDRX      	0x00000010        // End of Receiver Transfer
	#define AT91_SPI_SR_ENDTX      	0x00000020        // End of Transmitter Transfer
	#define AT91_SPI_SR_SPIENS     	0x00010000        // SPI Enable Status
	
#define AT91_SPI_IER           		0x14              // Interrupt Enable Register
#define AT91_SPI_IDR           		0x18              // Interrupt Disable Register
#define AT91_SPI_IMR           		0x1C              // Interrupt Mask Register

#define AT91_SPI_CSR0          		0x30              // Chip Select Register 0
#define AT91_SPI_CSR1          		0x34              // Chip Select Register 1
#define AT91_SPI_CSR2          		0x38              // Chip Select Register 2
#define AT91_SPI_CSR3          		0x3C              // Chip Select Register 3
	#define AT91_SPI_CSR_CPOL      	0x00000001        // Clock Polarity
	#define AT91_SPI_CSR_NCPHA     	0x00000002        // Clock Phase
	#define AT91_SPI_CSR_BITS(nbits)((nbits-8) << 4 )					
	
/*	
	#define AT91_SPI_CSR_BITS(x)   	(((x)&0x0F)<<4)   // Bits Per Transfer
	#define AT91_SPI_CSR_BITS8     	AT91_SPI_CSR_BITS(0)
	#define AT91_SPI_CSR_BITS9     	AT91_SPI_CSR_BITS(1)
	#define AT91_SPI_CSR_BITS10    	AT91_SPI_CSR_BITS(2)
	#define AT91_SPI_CSR_BITS11    	AT91_SPI_CSR_BITS(3)
	#define AT91_SPI_CSR_BITS12    	AT91_SPI_CSR_BITS(4)
	#define AT91_SPI_CSR_BITS13    	AT91_SPI_CSR_BITS(5)
	#define AT91_SPI_CSR_BITS14    	AT91_SPI_CSR_BITS(6)
	#define AT91_SPI_CSR_BITS15    	AT91_SPI_CSR_BITS(7)
	#define AT91_SPI_CSR_BITS16    	AT91_SPI_CSR_BITS(8)
*/	
  #define AT91_SPI_CSR_SCBR(x)   	(((x)&0xFF)<<8)   // Serial Clock Baud Rate 
  #define AT91_SPI_CSR_DLYBS(x)  	(((x)&0xFF)<<16)  // Delay Before SPCK
  #define AT91_SPI_CSR_DLYBCT(x) 	(((x)&0xFF)<<24)  // Delay Between two transfers


#define	AT91_SPI_RPR				0x100
#define	AT91_SPI_RCR				0x104
#define	AT91_SPI_TPR				0x108
#define	AT91_SPI_TCR				0x10C
#define	AT91_SPI_PTCR				0x120
  #define AT91_SPI_PTCR_RXTEN  		(1 << 0)
  #define AT91_SPI_PTCR_RXTDIS 		(1 << 1)
  #define AT91_SPI_PTCR_TXTEN  		(1 << 8)
  #define AT91_SPI_PTCR_TXTDIS 		(1 << 9)



#define AT91_SPI_MISO       		AT91_PIN(0,0,0) 	// SPI 0 Input
#define AT91_SPI_MOIS       		AT91_PIN(0,0,1) 	// SPI 0 Output
#define AT91_SPI_SPCK       		AT91_GPIO_PA2 		// SPI 0 clock
#define AT91_SPI_NPCS0  			AT91_PIN(0,0,3) 	// SPI 0 Chip Select 0
#define AT91_SPI_NPCS1  			AT91_PIN(0,0,4) 	// SPI 0 Chip Select 1 
//#define AT91_SPI_NPCS2  			AT91_PIN(0,0,5) 	// SPI 0 Chip Select 2 
#define AT91_SPI_NPCS2  			AT91_PIN(0,1,28) 	// SPI 0 Chip Select 2, alternate 
#define AT91_SPI_NPCS3  			AT91_PIN(0,0,6) 	// SPI 0 Chip Select 3 


#define AT91_SPI1_MISO       		AT91_PIN(1,0,30) 	// SPI 1 Input
#define AT91_SPI1_MOSI       		AT91_PIN(1,0,31) 	// SPI 1 Output
#define AT91_SPI1_SPCK       		AT91_PIN(1,0,29)	// SPI 1 clock
#define AT91_SPI1_NPCS0  			AT91_PIN(1,0,28) 	// SPI 1 Chip Select 0
#define AT91_SPI1_NPCS1  			AT91_PIN(0,1,24) 	// SPI 1 Chip Select 1 
#define AT91_SPI1_NPCS2  			AT91_PIN(0,1,25) 	// SPI 1 Chip Select 2 
#define AT91_SPI1_NPCS3  			AT91_PIN(0,1,26) 	// SPI 1 Chip Select 3 





#endif		// CYGONCE_HAL_VAR_SAM9_H


