#ifndef CYGONCE_USER_CONFIG_KEYS_H
#define CYGONCE_USER_CONFIG_KEYS_H
// ====================================================================
//
//      user_config_keys.h
//
//      Device I/O "Keys" for get/put config functions
//
// Author(s):    Ilko Iliev
// Date:         16-03-2006
// Purpose:      Repository for user get/put config "keys"
// Description:
//
//####DESCRIPTIONEND####
//
// ====================================================================

#define CYG_IO_USER_CONFIG_START					0x4000


// Config keys for I2C device driver ("/dev/i2c")
//===============================================
#define CYG_IO_CONFIG_I2C_FREQ						CYG_IO_USER_CONFIG_START + 0		// frequency in Hz

// Config keys for EEPROM device driver ("/dev/eeprom")
//=====================================================
#define CYG_IO_CONFIG_I2C_EEPROM_FREQ				CYG_IO_USER_CONFIG_START + 1		// frequency in Hz
#define CYG_IO_CONFIG_SIZE							CYG_IO_USER_CONFIG_START + 2		// frequency in Hz
#define CYG_IO_CONFIG_BLOCK_SIZE					CYG_IO_USER_CONFIG_START + 3		// frequency in Hz


// Config keays for device driver ("/dev/fspi" and "/dev/spi" )
//=============================================================
#define CYG_IO_CONFIG_SPI_DOUBLE_BUFF				CYG_IO_USER_CONFIG_START + 50		// info for double read/write buffer support
#define CYG_IO_CONFIG_SPI_FLAG_RXNEG				CYG_IO_USER_CONFIG_START + 51		// spi 	
#define CYG_IO_CONFIG_SPI_FLAG_TXNEG				CYG_IO_USER_CONFIG_START + 52		// spi
#define CYG_IO_CONFIG_SPI_FLAG_LSB					CYG_IO_USER_CONFIG_START + 53		// spi 	
#define CYG_IO_CONFIG_SPI_SET_CS					CYG_IO_USER_CONFIG_START + 54		// set spi chip select 	
#define CYG_IO_CONFIG_SPI_GET_CS					CYG_IO_USER_CONFIG_START + 55		// get spi chip select 	
#define CYG_IO_CONFIG_SPI_OE						CYG_IO_USER_CONFIG_START + 56		// enable outputs 	
#define CYG_IO_CONFIG_SPI_AUTOCHIPSELECT			CYG_IO_USER_CONFIG_START + 57		// 
#define CYG_IO_CONFIG_SPI_NBITS						CYG_IO_USER_CONFIG_START + 58		// number of bits 
#define CYG_IO_CONFIG_SPI_CLOCK						CYG_IO_USER_CONFIG_START + 59		// spi clock
#define CYG_IO_CONFIG_SPI_DLYBCS					CYG_IO_USER_CONFIG_START + 60		// delay between chip selects
#define CYG_IO_CONFIG_SPI_DLYBS						CYG_IO_USER_CONFIG_START + 61		// delay before SPCK
#define CYG_IO_CONFIG_SPI_DLYBCT					CYG_IO_USER_CONFIG_START + 62		// delay between consecutive transfers
#define CYG_IO_CONFIG_SPI_CPOL						CYG_IO_USER_CONFIG_START + 63		// clock polarity
#define CYG_IO_CONFIG_SPI_NCPHA						CYG_IO_USER_CONFIG_START + 64		// clock phase
 	

// Config keays for device driver ("/dev/mmc")
//=============================================
#define CYG_IO_CONFIG_MMC_CLOCK						CYG_IO_USER_CONFIG_START + 70		// mmc clock 
#define CYG_IO_CONFIG_MMC_GET_RDBLOCK_SIZE			CYG_IO_USER_CONFIG_START + 71		// mmc get read block size
#define CYG_IO_CONFIG_MMC_GET_WRBLOCK_SIZE			CYG_IO_USER_CONFIG_START + 72		// mmc get read block size
#define CYG_IO_CONFIG_MMC_GET_SECTOR_SIZE			CYG_IO_USER_CONFIG_START + 73		// mmc get sector size
#define CYG_IO_CONFIG_MMC_GET_CARD_SIZE				CYG_IO_USER_CONFIG_START + 74		// mmc get card capacity
#define	CYG_IO_CONFIG_MMC_IS_WRITE_PROTECT			CYG_IO_USER_CONFIG_START + 75		// get write protect status
#define	CYG_IO_CONFIG_MMC_GET_NUM_PAGES				CYG_IO_USER_CONFIG_START + 76		// get number of pages

// Config keays for device driver ("/dev/nvm1")
//=============================================
#define CYG_IO_CONFIG_EEP_CLOCK						CYG_IO_USER_CONFIG_START + 80		// eeprom clock
#define CYG_IO_CONFIG_EEP_SIZE						CYG_IO_USER_CONFIG_START + 81		// eeprom size in bytes
#define CYG_IO_CONFIG_EEP_WRITEPAGE_SIZE			CYG_IO_USER_CONFIG_START + 82		// write page size in bytes 
#define CYG_IO_CONFIG_EEP_READPAGE_SIZE				CYG_IO_USER_CONFIG_START + 83		// read  page size in bytes

#define CYG_IO_CONFIG_AUDIO_GET_BAT1				CYG_IO_USER_CONFIG_START + 90		// get battery voltage 1
#define CYG_IO_CONFIG_AUDIO_GET_BAT2				CYG_IO_USER_CONFIG_START + 91		// get battery voltage 2
#define CYG_IO_CONFIG_AUDIO_GET_KBD					CYG_IO_USER_CONFIG_START + 92		// get key-pad
#define CYG_IO_CONFIG_AUDIO_SET_AUDIO_RATE			CYG_IO_USER_CONFIG_START + 93		// set Audio sampling rate in Hz
#define CYG_IO_CONFIG_AUDIO_SET_VOLUME_LEFT			CYG_IO_USER_CONFIG_START + 94		// set Audio DAC volume for the left channel
#define CYG_IO_CONFIG_AUDIO_SET_VOLUME_RIGHT		CYG_IO_USER_CONFIG_START + 95		// set Audio DAC volume for the right channel
#define CYG_IO_CONFIG_AUDIO_SET_VOLUME				CYG_IO_USER_CONFIG_START + 96		// set Audio DAC volume for the both channels
#define CYG_IO_CONFIG_AUDIO_SET_MUTE_LEFT			CYG_IO_USER_CONFIG_START + 97		// set Audio DAC mute for the left channel
#define CYG_IO_CONFIG_AUDIO_SET_MUTE_RIGHT			CYG_IO_USER_CONFIG_START + 98		// set Audio DAC mute for the right channel
#define CYG_IO_CONFIG_AUDIO_SET_MUTE				CYG_IO_USER_CONFIG_START + 99		// set Audio DAC mute for the both channels
#define CYG_IO_CONFIG_AUDIO_RESET					CYG_IO_USER_CONFIG_START + 100		// reset the Audio DAC
#define CYG_IO_CONFIG_AUDIO_GET_BUFF_SIZE			CYG_IO_USER_CONFIG_START + 101		// get the size of ring buffer
#define CYG_IO_CONFIG_AUDIO_GET_MIXER_NUM			CYG_IO_USER_CONFIG_START + 102		// get number of mixer channels
#define CYG_IO_CONFIG_AUDIO_GET_FLAG_RUNNING		CYG_IO_USER_CONFIG_START + 103		// get flag_running
#define CYG_IO_CONFIG_AUDIO_GET_AUDIO_RATE			CYG_IO_USER_CONFIG_START + 104		// get Audio sampling rate in Hz
#define CYG_IO_CONFIG_AUDIO_GET_CHAN_BUSY			CYG_IO_USER_CONFIG_START + 105		// get status of mixer channel 0
#define CYG_IO_CONFIG_AUDIO_GET_CHAN0_BUSY			CYG_IO_USER_CONFIG_START + 105		// get status of mixer channel 0
#define CYG_IO_CONFIG_AUDIO_GET_CHAN1_BUSY			CYG_IO_USER_CONFIG_START + 106		// get status of mixer channel 1
#define CYG_IO_CONFIG_AUDIO_GET_CHAN2_BUSY			CYG_IO_USER_CONFIG_START + 107		// get status of mixer channel 2
#define CYG_IO_CONFIG_AUDIO_GET_CHAN3_BUSY			CYG_IO_USER_CONFIG_START + 108		// get status of mixer channel 3
#define CYG_IO_CONFIG_AUDIO_GET_CHAN4_BUSY			CYG_IO_USER_CONFIG_START + 109		// get status of mixer channel 4
#define CYG_IO_CONFIG_AUDIO_GET_CHAN5_BUSY			CYG_IO_USER_CONFIG_START + 110		// get status of mixer channel 5
#define CYG_IO_CONFIG_AUDIO_GET_CHAN6_BUSY			CYG_IO_USER_CONFIG_START + 111		// get status of mixer channel 6
#define CYG_IO_CONFIG_AUDIO_GET_CHAN7_BUSY			CYG_IO_USER_CONFIG_START + 112		// get status of mixer channel 7

#define CYG_IO_CONFIG_AUDIO_SET_MIC_GAIN			CYG_IO_USER_CONFIG_START + 113		// set microphone gain (0, 6 or 12 dB)
#define CYG_IO_CONFIG_AUDIO_SET_ADC_VOLUME			CYG_IO_USER_CONFIG_START + 114		// set ADC volume

#define	CYG_IO_CONFIG_FLASH_NAND_DATA				CYG_IO_USER_CONFIG_START + 120
#define	CYG_IO_CONFIG_FLASH_NAND_CMD				CYG_IO_USER_CONFIG_START + 121
#define	CYG_IO_CONFIG_FLASH_NAND_ADDR				CYG_IO_USER_CONFIG_START + 122
#define	CYG_IO_CONFIG_FLASH_NAND_READ8				CYG_IO_USER_CONFIG_START + 123
#define	CYG_IO_CONFIG_FLASH_NAND_ASSERT_CS			CYG_IO_USER_CONFIG_START + 124
#define	CYG_IO_CONFIG_FLASH_NAND_RELEASE_CS			CYG_IO_USER_CONFIG_START + 125
#define	CYG_IO_CONFIG_FLASH_NAND_SET_WIDTH			CYG_IO_USER_CONFIG_START + 126
#define	CYG_IO_CONFIG_FLASH_NAND_GET_RB_FUNC		CYG_IO_USER_CONFIG_START + 127
#define	CYG_IO_CONFIG_FLASH_NAND_ERASE_BLOCK		CYG_IO_USER_CONFIG_START + 128
#define	CYG_IO_CONFIG_FLASH_NAND_PAGE_SIZE			CYG_IO_USER_CONFIG_START + 129
#define	CYG_IO_CONFIG_FLASH_NAND_PAGES_PER_BLOCK	CYG_IO_USER_CONFIG_START + 130
#define	CYG_IO_CONFIG_FLASH_NAND_NUM_BLOCKS			CYG_IO_USER_CONFIG_START + 131
#define	CYG_IO_CONFIG_FLASH_NAND_MARK_BAD_BLOCK		CYG_IO_USER_CONFIG_START + 132





#endif  /* CYGONCE_USER_CONFIG_KEYS_H */
/* EOF user_config_keys.h */
